﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace MacButtonBar
{
	public partial class MacTray : UserControl
	{

        public MacTray()
		{
			// Required to initialize variables
			InitializeComponent();
		}

        public static readonly DependencyProperty BarOrientationProperty = DependencyProperty.Register(
            "BarOrientation",
            typeof(Orientation),
            typeof(MacTray),
            new PropertyMetadata(Orientation.Horizontal, new PropertyChangedCallback(MacTray.OnOrientationPropertyChanged)));

        public Orientation BarOrientation
        {
            get { return (Orientation)GetValue(BarOrientationProperty); }
            set { SetValue(BarOrientationProperty, value);
                    this.LayoutRoot.Orientation = BarOrientation;
                }
        }

        private static void OnOrientationPropertyChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            
        }

        private void TrayReset(object sender, MouseEventArgs e)
        {

            ReturnToNormal1.Begin();
            ReturnToNormal2.Begin();
            ReturnToNormal3.Begin();
            ReturnToNormal4.Begin();
            ReturnToNormal5.Begin();
            ReturnToNormal6.Begin();
            ReturnToNormal7.Begin();
            ReturnToNormal8.Begin();
            ReturnToNormal9.Begin();
            ReturnToNormal10.Begin();
            MarginReturn.Begin();

        }

        private void UserControl_MouseEnter(object sender, MouseEventArgs e)
        {
            this.LayoutRoot.Orientation = BarOrientation;

            Point mousePosition = e.GetPosition((UIElement)sender);
            double rangeMin = mousePosition.X - 250;
            double rangeMax = mousePosition.X + 250;

            FrameworkElement thisElement = sender as FrameworkElement;

            double distancePercent = ((thisElement.ActualWidth - mousePosition.X) / thisElement.ActualWidth);
            double renderCompensation = (180 * distancePercent) - 90;
            SplineDoubleKeyFrame compensationKey = new SplineDoubleKeyFrame();
            renderCorrection.Value = renderCompensation;
            //renderInfo.Text = renderCompensation.ToString();

            if (BarOrientation == Orientation.Vertical)
            {
                rangeMin = mousePosition.Y - 250;
                rangeMax = mousePosition.Y + 250;
            }
                

            Storyboard buttonStoryboard = new Storyboard();

            SplineDoubleKeyFrame heightKeyFrame = new SplineDoubleKeyFrame();
            SplineDoubleKeyFrame widthKeyFrame = new SplineDoubleKeyFrame();

            for (int i = 0; i < LayoutRoot.Children.Count; i++)
            {
                Button buttonInRange = (Button)LayoutRoot.Children[i];
                switch(buttonInRange.Name) 
                {
                    case "button1":
                        heightKeyFrame = btn1Height;
                        widthKeyFrame = btn1Width;
                        buttonStoryboard = this.OnEnter1;
                        break;
                    case "button2":
                        heightKeyFrame = btn2Height;
                        widthKeyFrame = btn2Width;
                        buttonStoryboard = this.OnEnter2;
                        break;
                    case "button3":
                        heightKeyFrame = btn3Height;
                        widthKeyFrame = btn3Width;
                        buttonStoryboard = this.OnEnter3;
                        break;
                    case "button4":
                        heightKeyFrame = btn4Height;
                        widthKeyFrame = btn4Width;
                        buttonStoryboard = this.OnEnter4;
                        break;
                    case "button5":
                        heightKeyFrame = btn5Height;
                        widthKeyFrame = btn5Width;
                        buttonStoryboard = this.OnEnter5;
                        break;
                    case "button6":
                        heightKeyFrame = btn6Height;
                        widthKeyFrame = btn6Width;
                        buttonStoryboard = this.OnEnter6;
                        break;
                    case "button7":
                        heightKeyFrame = btn7Height;
                        widthKeyFrame = btn7Width;
                        buttonStoryboard = this.OnEnter7;
                        break;
                    case "button8":
                        heightKeyFrame = btn8Height;
                        widthKeyFrame = btn8Width;
                        buttonStoryboard = this.OnEnter8;
                        break;
                    case "button9":
                        heightKeyFrame = btn9Height;
                        widthKeyFrame = btn9Width;
                        buttonStoryboard = this.OnEnter9;
                        break;
                    case "button10":
                        heightKeyFrame = btn10Height;
                        widthKeyFrame = btn10Width;
                        buttonStoryboard = this.OnEnter10;
                        break;
                }
                
                GeneralTransform gt = LayoutRoot.Children[i].TransformToVisual(sender as UIElement);
                Point offset = gt.Transform(new Point(0, 0));

                offset.X = offset.X + 20.0;
                offset.Y = offset.Y + 20.0;

                if (BarOrientation == Orientation.Horizontal)
                {
                    if (offset.X > rangeMin && offset.X < rangeMax)
                    {
                        heightKeyFrame.Value = widthKeyFrame.Value = 40 + 88 * (Math.Sin(Math.PI * ((offset.X - rangeMin) / 500)));
                        buttonStoryboard.Begin();
                        MarginAnimation.Begin();
                    }
                    else
                    {
                        heightKeyFrame.Value = widthKeyFrame.Value = 40;
                        buttonStoryboard.Begin();
                    }
                }
                else if (BarOrientation == Orientation.Vertical)
                {
                    if (offset.Y > rangeMin && offset.Y < rangeMax)
                    {
                        heightKeyFrame.Value = widthKeyFrame.Value = 40 + 88 * (Math.Sin(Math.PI * ((offset.Y - rangeMin) / 500)));
                        buttonStoryboard.Begin();
                        MarginAnimation.Begin();
                    }
                    else
                    {
                        heightKeyFrame.Value = widthKeyFrame.Value = 40;
                        buttonStoryboard.Begin();
                    }
                }

            }           

        }

    }
}